﻿// This file is part of BenLincoln.DebugSymbols.

// BenLincoln.DebugSymbols is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// BenLincoln.DebugSymbols is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with BenLincoln.DebugSymbols (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BenLincoln.DebugSymbols
{
    public class Utilities
    {
        public static string IndentString(string inputString, string indent)
        {
            StringBuilder resultBuilder = new StringBuilder();

            // handle cross-platform data correctly
            string lineBreak = "\r\n";

            if (!inputString.Contains("\r"))
            {
                lineBreak = "\n";
            }

            string input = inputString.Replace("\r", "");

            foreach (string line in inputString.Split(new char[] { '\n' }))
            {
                resultBuilder.Append(indent);
                resultBuilder.Append(line);
                resultBuilder.Append(lineBreak);
            }

            return resultBuilder.ToString();
        }
    }
}
